"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerContextHandleManager = void 0;
// 2 minutes
const DELAY = 1000 * 60 * 2;
const getId = (req) => {
    return req.socket.remoteAddress + '_' + req.socket.remotePort;
};
class ServerContextHandleManager {
    constructor() {
        this.cache = [];
    }
    release(req) {
        this.refresh();
        this.cache = this.cache.filter((v) => v.id !== getId(req));
    }
    get(req) {
        var _a;
        this.refresh();
        return (_a = this.cache.find((v) => v.id === getId(req))) === null || _a === void 0 ? void 0 : _a.handle;
    }
    set(req, handle) {
        this.refresh();
        const item = this.cache.find((v) => v.id === getId(req));
        if (item) {
            item.handle = handle;
            return;
        }
        this.cache.push({
            id: getId(req),
            handle,
            timestamp: new Date().getTime(),
        });
    }
    refresh() {
        this.cache = this.cache.filter((v) => v.timestamp > new Date().getTime() - DELAY);
    }
}
exports.ServerContextHandleManager = ServerContextHandleManager;
//# sourceMappingURL=ServerContextHandleManager.js.map